unit serverUnit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPServer, idtcpconnection;

type
  TForm1 = class(TForm)
    IdTCPServer1: TIdTCPServer;
    procedure IdTCPServer1Execute(AThread: TIdPeerThread);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure doStart(con:TIdTcpConnection);
    procedure doLogin(con:TIdTcpConnection);
    procedure doError(con:TIdTcpConnection);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.doError(con:TIdTcpConnection);
begin
  con.WriteLn('error');
end;

procedure TForm1.doLogin(con:TIdTcpConnection);
var usr,pwd:string;
begin
  usr:=con.readln;
  pwd:=con.readln;
  con.writeln('login_r');
  con.Writeln(booltostr(usr=pwd));// do the check and send the result. in this case we assume that a good password is the username itself
end;

procedure TForm1.doStart(con:TIdTcpConnection);
var l:tstringlist;
    i:integer;
begin
  l:=tstringlist.create;// fill teh userlist here from db or whatever
  l.add('usr1');
  l.add('usr2');
  l.add('usr3');
  con.writeln('start_r');
  con.writeln(inttostr(l.count));
  for i:=1 to l.count do
    con.writeln(l[i-1]);
  l.free;
end;

procedure TForm1.IdTCPServer1Execute(AThread: TIdPeerThread);
var cmd:string;
begin
  cmd:=lowercase(athread.Connection.ReadLn);
  if cmd='start' then
    doStart(athread.Connection)
  else
  if cmd='login' then
    doLogin(athread.Connection)
  else
    doError(athread.Connection);
end;

end.
